package require Tk
lappend ::auto_path .
package require TkXext

proc loop.resize {id i} {
 if {$i > 500} {
  return
 }
 
 TkXext.resize.window $id $i $i
 incr i 10
 after 60 [list loop.resize $id $i]
}

proc resize.embedded.window {emId win w h} {
 set bd [$win cget -bd]

 set width_incr 1
 set height_incr 1
 set incrList [TkXext.get.resize.increments $emId]

 if {[llength $incrList]} {
  foreach {width_incr height_incr} $incrList break
 }

 if {$width_incr <= 0} {
  set width_incr 1
 }

 if {$height_incr <= 0} {
  set height_incr 1
 }
 if 0 {
 set newWidth [expr {$w - ($bd * 2)}]
 set newHeight [expr {$h - ($bd * 2)}]
 set modWidth [expr {$newWidth % $width_incr}]
 set modHeight [expr {$newHeight % $height_incr}]
 set newWidth [expr {$newWidth - $modWidth}]
 set newHeight [expr {$newHeight - $modHeight}]
 }

 set w [expr {$w - ($bd * 2)}]
 set h [expr {$h - ($bd * 2)}]

 set modWidth [expr {$w % $width_incr}]
 set modHeight [expr {$h % $height_incr}]
 
 set newWidth [expr {$w - $modWidth}]
 set newHeight [expr {$h - $modHeight}]

 TkXext.resize.window $emId $newWidth $newHeight
}

proc cleanup pid_list {
 foreach p $pid_list {
  catch {exec kill $p}
 }
 exit
}

proc send.greeting win {
 set oldX [winfo pointerx .]
 set oldY [winfo pointery .]

 set x [expr {[winfo rootx $win] + 5}]
 set y [expr {[winfo rooty $win] + 5}]

 TkXext.move.pointer $x $y

 TkXext.send.string "Hello World"
 TkXext.send.string "\[A comment in brackets\]"

 TkXext.move.pointer $oldX $oldY
}

proc main {} {
 pack [labelframe .xtermFrame -text xterm -container 1 -width 300 -height 220] -fill both -expand 1
 pack [labelframe .xeditFrame -text xedit -container 1 -width 300 -height 200] -fill both -expand 1 
 pack [labelframe .xcalcFrame -text xcalc -container 1 -width 300 -height 250] -fill both -expand 1

 lappend pid_list [exec xterm -T XTERM_EMBED_ME -xrm "xterm*allowSendEvents:true" &]
 set xtermWinId [TkXext.find.window XTERM_EMBED_ME] 
 TkXext.reparent.window $xtermWinId [winfo id .xtermFrame]
 bind .xtermFrame <Configure> [list resize.embedded.window $xtermWinId %W %w %h]
 bind .xtermFrame <Configure> [list TkXext.focus $xtermWinId]

 lappend pid_list [exec xedit -title XEDIT_EMBED_ME /tmp/wow &]
 set xeditWinId [TkXext.find.window XEDIT_EMBED_ME]
 TkXext.reparent.window $xeditWinId [winfo id .xeditFrame]
 bind .xeditFrame <Configure> [list resize.embedded.window $xeditWinId %W %w %h]
 bind .xeditFrame <Enter> [list TkXext.focus $xeditWinId]

 lappend pid_list [exec xcalc -title XCALC_EMBED_ME &]
 set xcalcWinId [TkXext.find.window XCALC_EMBED_ME]
 TkXext.reparent.window $xcalcWinId [winfo id .xcalcFrame]
 bind .xcalcFrame <Configure> [list resize.embedded.window $xcalcWinId %W %h %h]
 bind .xcalcFrame <Enter> [list TkXext.focus $xcalcWinId]

 wm protocol . WM_DELETE_WINDOW [list cleanup $pid_list]

 pack [button .b -text {Send Greeting} -command [list send.greeting .xeditFrame]]
}
main
